	*****************************************************************
	* Program obslugi digitizera video - Frame Grabber /FASTD9.s/   *
	* Pracuje na czterech planach - w czasie rzeczywistym           *
	*****************************************************************

 	* deklaracje stalych programu *

gemdos:	EQU	$01
xbios:	EQU	$0E
memtop:	EQU	$436
colreg:	EQU	$FF8240
super:	EQU	$20


	TEXT

start_up:			; sekwencja startowa programu
	move.l	4(sp),a0
	move.l	12(a0),d0
	add.l	20(a0),d0
	add.l	28(a0),d0
	add.l	#$1000,d0
	add.l	#$100,d0
	move.l	d0,-(sp)
	move.l	a0,-(sp)
	clr.w	-(sp)
	move.w	#$4A,-(sp)	; zwolnienie reszty RAM
	trap	#gemdos
	lea	12(sp),sp
				
	move.l	4(sp),a0	; wolna RAM?
	move.l	12(a0),d0
	add.l	20(a0),d0
	add.l	28(a0),d0
	add.l	#$1000,d0
	add.l	#$100,d0
	add.l	a0,d0
	move.l	d0,next_mem

	pea	0		; tryb Master
	move.w	#super,-(sp)
	trap	#gemdos	
	addq.l	#6,sp

	move.w	#4,-(sp)
	trap	#xbios		; tryb rozdzielczosci
	addq.l	#2,sp
	move.w	d0,r_mode
	
	move.l	memtop,oldmem	; przesuniecie MEMTOP + przechowanie
	move.l	$44e,d0
	move.l	d0,ekr_fiz
	move.l	d0,ekr_log
	sub.l	#$8000,d0	; obszar #$8000 long ponizej adresu
	move.l	d0,ekr_buf	; ekranu fizycznego - tu bufor dla	
	move.l	d0,memtop	; DOUBLEFRAME
	move.l	d0,a5		; adres bufora do reg.A5
	move.l	a5,a4		

	suba.l	next_mem,a4	; oblicza liczbe ramek w RAM
	move.l	a4,d0
	divu.w	#32000,d0	; 32000 bajtow - rozmiar ekranu
	move.w 	d0,no_frames	; wynik do zmiennej

	move.w	#$00,-(sp)	; niska rozdzielczosc
	move.l	#-1,-(sp)
	move.l	#-1,-(sp)
	move.w	#5,-(sp)
	trap	#xbios		
	add.l	#10,sp

	bsr	mouse_off	; wylacz mysz

	movem.l	colreg,d0-d7	; zachowaj stare kolory
	movem.l	d0-d7,oldpal
	
	jsr	intro		; uruchamia intro
	jsr	info		; ekran informacji ogolnych

	move.l	#defpal,palette	; ustawienie poczatkowej palety kolorow

clear_sc1:	move.l	#$1F3F,d0	; kasuje obszar ekr. fizycznego
	move.l	ekr_fiz,a0

clrloop1:	clr.l	(a0)+
	dbf	d0,clrloop1	

clear_sc2:	move.l	#$1F3F,d0	; Clear screen buffer
	move.l	ekr_buf,a0

clrloop2:	clr.l	(a0)+
	dbf	d0,clrloop2	

	movem.l	defpal9,d0-d7	; paleta poczatkowa do rejestrow
	movem.l	d0-d7,colreg
	move.l	ekr_buf,a5	; na poczatek adres bufora

	***********************************************************		
	* Tu zaczyna sie glowna petla programu obslugi digitizera *
	***********************************************************

sys_run:	
	move.w	#$2700,sr	; IPL 7 - blokada przerwan
	move.w	$fa0000,d0	; uruchomienie digitalizacji ramki
waitin:	cmp.w	#$ffff,$faff00	; proces zakonczony  (TRUE)
	bne	waitin		; jesli bit 0 <>FALSE - czekaj

	move.w	#$0B,-(sp)	; status klawiatury
	trap	#gemdos
	addq.l	#2,sp
	tst.w	d0		; d0=0 - brak nacisniecia klawisza
	beq	dodaj
	
	move.w	#$2300,sr	; IPL 3 - poziom przerwan
	bsr	keyboard	; obsluga klawiatury
	move.w	#$2700,sr	; IPL 7 - blokada przerwan
dodaj:	move.l	#$FB0000,a0	; adres danych pobieranych

	rept 	16000		
	move.w	(a0)+,(a5)+	; 16000 przeslan z digitizera do RAM ekranu
	endr

	;move.l	ekr_fiz,a5	; adres ekranu do A5
	
	;	*** sekcja DOUBLEFRAME ***
	
	cmp.w	#0,scflag
	bne	zmiana
	move.l	ekr_buf,$44e		; nowy adr logiczny
	move.b	ekr_buf+1,$ffff8201	; Hard adr fizyczny
	move.b	ekr_buf+2,$ffff8203
	move.l	ekr_fiz,a5
	move.w	#1,scflag
	bra 	go_back
zmiana:
	move.l	ekr_fiz,$44e		; nowy adr logiczny
	move.b	ekr_fiz+1,$ffff8201	; Hard adr fizyczny
	move.b	ekr_fiz+2,$ffff8203
	move.l	ekr_buf,a5
	move.w	#0,scflag
go_back:	
	move.w	#$2300,sr	; IPL 3 - przywrocenie przerwan
	bra	sys_run			; zamkniecie petli programu

terminate:	
	movem.l	oldpal,d0-d7		; zwrocenie palety 
	movem.l	d0-d7,colreg	
	move.w	r_mode,-(sp)	
	move.l	ekr_fiz,-(sp)
	move.l	ekr_fiz,-(sp)
	move.w	#5,-(sp)
	trap	#xbios		; zwrocenie starej rozdzielczosci
	add.l	#10,sp
	
	bsr	mouse_on	; wlaczenie myszy

	move.l	oldmem,memtop	; przywrocenie MEMTOP

	clr.w	-(sp)		; TERMINATE
	move.w	#$4C,-(sp)
	trap	#gemdos		; koniec pracy programu...
	
	**************************************************
	*  Blok podprogramow obslugi zdarzen systemu...  *
	**************************************************

mouse_on:			
	pea	mousen		; wlacz mysz
	bra	ikbd_out

mouse_off:
	pea	mousdi		; wylacz mysz

ikbd_out:			
	move.w	#0,-(sp)	; wyslij komende do procesora klawiatury
	move.w	#25,-(sp)
	trap	#xbios
	addq.l	#8,sp
	rts

	***********************************
	*  Obsluga nacisnietego klawisza  *
	***********************************

keyboard:			; obsluga klawiatury
	move.w	#8,-(sp)	; wczytanie znaku z klawiatury
	trap	#gemdos
	addq.l	#2,sp
key2:				; pytanie o klawisze funkcyjne

	cmp.l	#$3B0000,d0	; F1 ?
	beq	paleta1
	cmp.l	#$3C0000,d0	; F2 ?
	beq	paleta2
	cmp.l	#$3D0000,d0	; F3 ?
	beq	paleta3
	cmp.l	#$3E0000,d0	; F4 ?
	beq	paleta4
	cmp.l	#$3F0000,d0	; F5 ?
	beq	paleta5
	cmp.l	#$400000,d0	; F6 ?
	beq	paleta6
	cmp.l	#$410000,d0	; F7 ?
	beq	paleta7
	cmp.l	#$420000,d0	; F8 ?
	beq	paleta8
	cmp.l	#$430000,d0	; F9 ?
	beq	paleta9
	cmp.l	#$440000,d0	; F10 ?
	beq	paleta10
	cmp.l	#$620000,d0
	bne	nextst
	bsr	help
nextst:
	andi.w	#$ff,d0		; Esc
	cmp.b	#$1B,d0
	bne	out1
	
	addq.	#2,sp		; zdejmij adres powrotu i BRA
	bra 	terminate	; do zakonczenia pracy
	
out1:	cmp.b	#$73,d0		; "S" - start sekwencji
	beq	write_anim

out2:	cmp.b	#$20,d0		; spacja - zapis obrazu na dysk
	bne	ret
	bra	save_it
	
ret:	rts

	*******************************************
	*  Procedury zapisu ekranu na dysk *.PI1  *
	*******************************************

save_it:			; zapis obrazu na dysk
	move.w	#2,-(sp)	; wziecie aktualnego adresu ekranu
	trap	#xbios
	addq.l	#2,sp
	move.l	#399,d4		; zachowanie pierwszych 1600 bajtow
	move.l	#lbuf,a3
	move.l	d0,a4
run_it:	move.l	(a4)+,(a3)+	
	dbf	d4,run_it
	
	pea	warn		; wyslanie komunikatu o zapisie
	move.w	#9,-(sp)
	trap	#gemdos
	lea	6(sp),sp
	pea	bufor
	move.w	#$A,-(sp)	; wczytanie nazwy z klawiatury
	trap	#gemdos
	lea	6(sp),sp
	lea	namfil,a0
	add.w	d0,a0	
	move.b	#'.',(a0)
	move.b	#'P',1(a0)
	move.b	#'I',2(a0)
	move.b	#'1',3(a0)
	move.b	#0,4(a0)
	move.w	#$20,-(sp)

	pea	cline		; kasowanie tekstu
	move.w	#9,-(sp)
	trap	#gemdos
	lea	6(sp),sp
	
	pea	namfil		; utworzenie pliku oraz zapis
	move.w	#$3C,-(sp)
	trap	#gemdos
	addq.l	#8,sp
	move.w	d0,handle
	pea	header
	move.l	#2,-(sp)
	move.w	handle,-(sp)
	move.w	#$40,-(sp)
	trap	#gemdos
	lea	$C(sp),sp
	move.l	palette,-(sp)
	move.l	#32,-(sp)
	move.w	handle,-(sp)
	move.w	#$40,-(sp)
	trap	#gemdos
	lea	$C(sp),sp
	move.w	#2,-(sp)
	trap	#xbios
	addq.l	#2,sp
	move.l	d0,-(sp)
	
	move.l	#399,d4
	move.l	#lbuf,a3
	move.l	d0,a4
run_it2:	move.l	(a3)+,(a4)+
	dbf	d4,run_it2
	
	move.l	#32000,-(sp)
	move.w	handle,-(sp)
	move.w	#$40,-(sp)
	trap	#gemdos
	lea	$C(sp),sp
	move.w	handle,-(sp)
	move.w	#$3E,-(sp)
	trap	#gemdos
	addq.l	#4,sp
	rts	


paleta1:	move.l	#defpal,palette	; przepisanie palet do rejestrow
		move.l	#defpal,$45A
		rts	
paleta2:	move.l	#defpal1,palette
		move.l	#defpal1,$45A
		rts	
paleta3:	move.l	#defpal2,palette
		move.l	#defpal2,$45A
		rts	
paleta4:	move.l	#defpal3,palette
		move.l	#defpal3,$45A
		rts	
paleta5:	move.l	#defpal4,palette
		move.l	#defpal4,$45A
		rts	
paleta6:	move.l	#defpal5,palette
		move.l	#defpal5,$45A
		rts	
paleta7:	move.l	#defpal6,palette
		move.l	#defpal6,$45A
		rts	
paleta8:	move.l	#defpal7,palette
		move.l	#defpal7,$45A
		rts	
paleta9:	move.l	#defpal8,palette
		move.l	#defpal8,$45A
		rts	
paleta10:	move.l	#defpal9,palette
		move.l	#defpal9,$45A
		rts	

	*************************************************
	* Sekcja zapisu animacji do RAM w cyklu odczytu *
	*************************************************

write_anim:

	movem.l	d0-d7,-(sp)	; rejestry na stos!
	movem.l	a0-a6,-(sp)

	clr.l	d7
	move.l	next_mem,a0
	move.l	a0,fr_count	; adres RAM do licznika adresow ramek
	move.w	no_frames,d7	; liczba ramek do licznika
	subi.w	#$1,d7

movement:			; odczyt ramek z digitizera oraz zapis w RAM
	
	move.w	$fa0000,d0
	nop
sync:	cmp.w	#$ffff,$faff00
	bne	sync

	move.l #$FB0000,a1	; adres pierwszego slowa z cartridge
	move.w	#15999,d1	
movs:	move.w (a1)+,(a0)+
	dbf	d1,movs
	
	dbf	d7,movement

	move.	#7,-(sp)	; dzwonek - sygnal konca wczytywania
	move.w	#2,-(sp)
	trap	#gemdos
	addq.l	#4,sp

	bsr replay		; pierwsze odtworzenie

	movem.l	(sp)+,a0-a6	; rejestry ze stosu! - powrot
	movem.l	(sp)+,d0-d7

	rts

	*********************************
	*  Odtwarzanie sekwencji z RAM  *
	*********************************  

replay:				; procedura odtwarzania z RAM
	clr.l	d6
	move.w	#2,-(sp)
	trap	#xbios
	addq.l	#2,sp
	move.l	next_mem,a0
	move.w	no_frames,d6
	subi.w	#1,d6


repl3:	move.l	#$2500,d2	; przepisywanie z RAM do ekranu
	move.l	#15999,d5	; w petli + opoznienie
	move.l	d0,a1
repl1:	move.w	(a0)+,(a1)+
	dbf	d5,repl1
weitz:	
	nop
	nop
	nop
	nop
	dbf	d2,weitz
	dbf	d6,repl3


rept:				; czekanie na klawisz
	move.w	#8,-(sp)
	trap	#gemdos
	addq.l	#2,sp
	cmp.b	#'r',d0
	beq	replay		; r - ponowne odtworzenie sekwencji
	cmp.b	#$1B,d0
	beq	endseq		; Esc - wyjscie z obslugi sekwencji
	cmp.b	#$20,d0		; spacja - zapis wybranej ramki
	bne	tile1
	bsr	save_it 
tile1:	cmp.b	#'+',d0		; "+" - nastepna ramka
	bne	tile2
	bsr	fr_next
tile2:	cmp.b	#'-',d0		; "-" - poprzednia ramka
	bne	tile3
	bsr	fr_prev
tile3:
	bsr	key2		; obsluga zmiany palet
	bra	rept

endseq:	rts			; koniec podprogramu sekwencji


	*********************************************
	* procedury zmiany ramek w trybie sekwencji *
	*********************************************

fr_next:			; nastepna ramka

	move.l	$44e,d3
	move.l	d3,a2
	add.l	#$7d00,fr_count ; #$7d00 bajtow - dlugosc obrazu
	move.l	fr_count,a0	; liczba dostepnych ramek		
	move.l	#$1f3f,d5
re1	move.l	(a0)+,(a2)+	; przepisanie ramki na ekran
	dbf	d5,re1

	rts
	
fr_prev:			; poprzednia ramka
 	move.l	$44e,d3
	move.l	d3,a2
	sub.l	#$7d00,fr_count
	move.l	fr_count,a0
	move.l	#$1f3f,d5
rel1	move.l	(a0)+,(a2)+
	dbf	d5,rel1
	
	rts 

	********************
	* intro subroutine *
	********************

intro:
	bsr	scr_kas
	move.w	#$777,colreg
	bsr	bak_mans
	bsr	weit
	bsr	bak_mana
	move.l	#picture+34,a1
	bsr	pic_load
	move.l	#15,d5
	movea.l	#colreg,a0
colset: move.w	#$fff,(a0)+
	dbf	d5,colset
	movea.l	#palrot,a4
	move.l	#5,d6
	bsr	set_pic
	move.w	#8,-(sp)
	trap	#gemdos
	addq.l	#2,sp
	movea.l	#palrot+160,a4
	move.l	#5,d6
	bsr	unset_pic
	rts

	******************
	* procedura HELP *
	******************

help:
	move.l	#helpic+34,a1
	bsr	pic_load
	move.w	#8,-(sp)
	trap	#gemdos
	addq.l	#2,sp
	bsr	scr_kas
	rts

	******************	
	* procedure INFO *
	******************
info:	
	move.l	#infopic+34,a1
	bsr	pic_load
	movea.l	#palrot,a4
	move.l	#5,d6
	bsr	set_pic
	move.w	#8,-(sp)
	trap	#gemdos
	addq.l	#2,sp
	movea.l	#palrot+160,a4
	move.l	#5,d6
	bsr	unset_pic
	bsr	scr_kas
        move.w	#$777,colreg
	bsr	bak_mans
	rts	

;       *************************************
;       *  Procedury uzytkowe...intro+info  *
;       *************************************

scr_kas:
	move.l	$44e,d0
	move.l	d0,a0
	move.l	#$1f3f,d1
pecl:	clr.l	(a0)+
	dbf	d1,pecl
	rts

bak_mans:
	move.l	#6,d2
	clr.l	d3
        move.w	colreg,d3
subs:	sub.w	#$111,d3
	move.w	#37,-(sp)
	trap	#xbios
	addq.l	#2,sp
	move.w	#37,-(sp)
	trap	#xbios
	addq.l	#2,sp
	move.w	d3,colreg	
	dbf	d2,subs
	rts

bak_mana:
	move.w	#37,-(sp)
	trap	#xbios
	addq.l	#2,sp
	move.l	#6,d2
	clr.l	d3
        move.w	colreg,d3
adds:	add.w	#$111,d3
	move.w	d3,colreg	
	dbf	d2,adds
	rts

weit:
	move.l	#1000,d5
wpl:	dbf	d5,wpl
	rts

set_pic:
	
seti:	move.l	#7,d5
	movea.l	#colreg,a3
	move.w	#37,-(sp)
	trap	#xbios
	addq.l	#2,sp
clrcol: move.l	(a4)+,(a3)+
	dbf	d5,clrcol
	move.w	#37,-(sp)
	trap	#xbios
	addq.l	#2,sp	
	move.l	#20000,d5
wpl1:	dbf	d5,wpl1	
	dbf	d6,seti		
	rts

pic_load:
	move.l	$44e,d0
	move.l	d0,a0
	move.l	#7999,d2
picl:	move.l	(a1)+,(a0)+
	dbf	d2,picl
	rts

unset_pic:

seti2:	move.l	#7,d5
	movea.l	#colreg,a3
	move.w	#37,-(sp)
	trap	#xbios
	addq.l	#2,sp
clrcol2: move.l	(a4)+,(a3)+
	dbf	d5,clrcol2
	move.w	#37,-(sp)
	trap	#xbios
	addq.l	#2,sp	
	sub.l	#64,a4
	dbf	d6,seti2		
	rts

	DATA			; obszar danych programu

fr_count:	dc.l	0
handle:		dc.w	$0
mousen:		dc.b	$08
mousdi:		dc.b	$12
scflag:		dc.w	$0
r_mode:		dc.w	$0
ekr_fiz:	dc.l	$0
ekr_log:	dc.l	$0
ekr_buf:	dc.l	$0
oldmem:		dc.l	$0
palette:	dc.l	$0
header:		dc.w	$0

defpal:	
	dc.w 	$000		; definicje palet
	dc.w	$001
	dc.w 	$111
	dc.w	$112
	dc.w 	$222
	dc.w 	$223
	dc.w 	$333
	dc.w 	$334
	dc.w 	$444
	dc.w 	$445
	dc.w 	$555
	dc.w 	$556
	dc.w 	$666
	dc.w 	$667
	dc.w 	$677
	dc.w 	$777

defpal1:
	dc.w 	$000
	dc.w	$311
	dc.w 	$411
	dc.w	$511
	dc.w 	$720
	dc.w 	$730
	dc.w 	$740
	dc.w 	$750
	dc.w 	$751
	dc.w 	$762
	dc.w 	$763
	dc.w 	$773
	dc.w 	$774
	dc.w 	$775
	dc.w 	$776
	dc.w 	$777

defpal2:
	dc.w 	$000
	dc.w	$100
	dc.w 	$200
	dc.w	$310
	dc.w 	$421
	dc.w 	$521
	dc.w 	$532
	dc.w 	$632
	dc.w 	$643
	dc.w 	$743
	dc.w 	$754
	dc.w 	$764
	dc.w 	$765
	dc.w 	$775
	dc.w 	$776
	dc.w 	$777

defpal3:
	dc.w 	$000
	dc.w	$000
	dc.w 	$111
	dc.w	$111
	dc.w 	$222
	dc.w 	$222
	dc.w 	$333
	dc.w 	$333
	dc.w 	$444
	dc.w 	$444
	dc.w 	$555
	dc.w 	$555
	dc.w 	$666
	dc.w 	$666
	dc.w 	$777
	dc.w 	$777

defpal4:	
	dc.w	$000
	dc.w 	$010
	dc.w	$110
	dc.w 	$121
	dc.w 	$221
	dc.w 	$232
	dc.w 	$332
	dc.w 	$343
	dc.w 	$443 
	dc.w 	$454
	dc.w 	$554
	dc.w 	$565
	dc.w 	$665
	dc.w 	$676
	dc.w 	$776
	dc.w	$777

defpal5:
	dc.w 	$000
	dc.w	$110
	dc.w 	$210
	dc.w	$320
	dc.w 	$321
	dc.w 	$431
	dc.w 	$432
	dc.w 	$542
	dc.w 	$543
	dc.w 	$653
	dc.w 	$654
	dc.w 	$764
	dc.w 	$765
	dc.w 	$775
	dc.w 	$776
	dc.w 	$777

defpal6:	
	dc.w 	$000
	dc.w	$001
	dc.w 	$101
	dc.w	$112
	dc.w 	$212
	dc.w 	$223
	dc.w 	$323
	dc.w 	$334
	dc.w 	$434
	dc.w 	$445
	dc.w 	$545
	dc.w 	$556
	dc.w 	$656
	dc.w 	$667
	dc.w 	$767
	dc.w 	$777

defpal7:
	dc.w 	$000
	dc.w	$010
	dc.w 	$011
	dc.w	$121
	dc.w 	$122
	dc.w 	$232
	dc.w 	$233
	dc.w 	$343
	dc.w 	$344
	dc.w 	$454
	dc.w 	$455
	dc.w 	$565
	dc.w 	$566
	dc.w 	$676
	dc.w 	$677
	dc.w 	$777

defpal8:
	dc.w 	$000
	dc.w	$100
	dc.w 	$101
	dc.w	$211
	dc.w 	$212
	dc.w 	$322
	dc.w 	$323
	dc.w 	$433
	dc.w 	$434
	dc.w 	$544
	dc.w 	$545
	dc.w 	$655
	dc.w 	$656
	dc.w 	$766
	dc.w 	$767
	dc.w 	$777

defpal9:
	dc.w 	$000
	dc.w	$011
	dc.w 	$012
	dc.w	$023
	dc.w	$123
	dc.w 	$134
	dc.w 	$234
	dc.w 	$245
	dc.w 	$345
	dc.w 	$356
	dc.w 	$456
	dc.w 	$467
	dc.w 	$567
	dc.w 	$577
	dc.w 	$677
	dc.w 	$777
	
	
warn:	dc.b	$1B,'H',$1B,'KOut name (max 8 chars)... : ',0
	
	even

palrot:			; 6 sztuk po 16 slow do intro i info
	dc.w 	$666
	dc.w	$766
	dc.w 	$766
	dc.w	$776
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$555
	dc.w	$655
	dc.w 	$655
	dc.w	$665
	dc.w 	$776
	dc.w 	$776
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$444
	dc.w	$544
	dc.w 	$544
	dc.w	$554
	dc.w 	$655
	dc.w 	$665
	dc.w 	$776
	dc.w 	$776
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$222
	dc.w	$322
	dc.w 	$322
	dc.w	$432
	dc.w 	$433
	dc.w 	$443
	dc.w 	$554
	dc.w 	$654
	dc.w 	$776
	dc.w 	$776
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$111
	dc.w	$211
	dc.w 	$211
	dc.w	$321
	dc.w 	$322
	dc.w 	$332
	dc.w 	$433
	dc.w 	$443
	dc.w 	$544
	dc.w 	$654
	dc.w 	$655
	dc.w 	$765
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777
	dc.w 	$777	
	dc.w 	$000
	dc.w	$100
	dc.w 	$200
	dc.w	$310
	dc.w 	$421
	dc.w 	$521
	dc.w 	$532
	dc.w 	$632
	dc.w 	$643
	dc.w 	$743
	dc.w 	$754
	dc.w 	$764
	dc.w 	$765
	dc.w 	$775
	dc.w 	$776
	dc.w 	$777

cline:	dc.b	$1B,'l',0,0	
bufor:	dc.w	$800

namfil:	ds.w	$A
picture:	incbin	"manfan.pi1"
infopic:	incbin	"infopic.pi1"
helpic:		incbin  "helpic.pi1"

	BSS
oldpal:		ds.w	$10
lbuf:		ds.l	$801
next_mem:	ds.l	1
no_frames:	ds.w	1

	
	END




